



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>django-celery的配置及使用</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">django-celery的配置及使用</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-28 23:06:47 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<h1>Celery简介</h1>
<p>Celery 是一个 基于python开发的分布式异步消息任务队列，通过它可以轻松的实现任务的异步处理</p>
<h2>celery的应用</h2>
<p>异步调用：那些用户不关心的但是又存在在我们API里面的操作 我们就可以用异步调用的方式来优化（发送邮件 或者上传头像）</p>
<p>​定时任务：定期去统计日志，数据备份，或者其他的统计任务</p>
<h3>相关概念</h3>
<p>task:需要执行的任务</p>
<p>worker:负责干活的小弟们</p>
<p>broker:结果存放的位置</p>
<h2>celery的安装和使用</h2>
<div>
<div>
<pre class="prettyprint linenums">pip install celery<br />
pip install celery-with-redis<br />
pip install django-celery<br />
apt install redis-server</pre>
</div>
<p>安装</p></div>
<h3>配置</h3>
<div>
<div>
<pre class="prettyprint linenums">ALLOWED_HOSTS = ['*']<br />
INSTALLED_APPS = (<br />
      ...<br />
      'djcelery',<br />
&lsquo;自己的APP&rsquo;<br />
    }<br />
import djcelery<br />
djcelery.setup_loader()<br />
BROKER_URL='redis://localhost:6379/1'<br />
CELERY_CONCURRENCY=2（设置worker的并发数量）<br />
CELERY_RESULT_BACKEND = 'redis://localhost:6379/2'</pre>
</div>
<p>settings.py文件</p></div>
<h3>settings.py的同级目录下新建celery.py</h3>
<div>
<div>
<pre class="prettyprint linenums">from __future__ import absolute_import #绝对路径导入<br />
from celery import Celery<br />
from django.conf import settings<br />
import os

#设置系统的环境配置用的是Django的<br />
os.environ.setdefault("DJANGO_SETTING_MODULE", "工程名字.settings")

#实例化celery<br />
app = Celery('mycelery')

app.conf.timezone = "Asia/Shanghai"

#指定celery的配置来源 用的是项目的配置文件settings.py<br />
app.config_from_object("django.conf:settings")

#让celery 自动去发现我们的任务（task）<br />
app.autodiscover_tasks(lambda : settings.INSTALLED_APPS) #你需要在app目录下 新建一个叫tasks.py（一定不要写错）文件</pre>
</div>
<p>celery.py</p></div>
<h3>settings.py同级目录下的init.py加入</h3>
<div>
<div>
<pre class="prettyprint linenums">from __future__ import absolute_import, unicode_literals<br />
from .celery import app as celery_app</pre>
</div>
<p>__init__.py</p></div>
<h3>使用</h3>
<h3>1、在需要使用异步任务的APP目录下新建tasks.py</h3>
<div>
<div>
<pre class="prettyprint linenums">from celery import task<br />
import time

@task<br />
def hello_celery(loop):<br />
    for i in range(loop):<br />
        print 'hello'<br />
        time.sleep(2)</pre>
</div>
<p>tasks.py</p></div>
<h3>2、views.py内的调用</h3>
<div>
<pre class="prettyprint linenums">任务函数名.delay(参数，，，，)</pre>
</div>
<h3>3、python manage.py migrate 建表（不要忘记建表）</h3>
<h3>4、启动worker</h3>
<h3>python manage.py celery worker --loglevel=info (或者celery -A 你的工程名 worker -l info)</h3>
<h3>注意：修改tasks.py的内容后 要重启celery的服务（命令：python manage.py celery worker --loglevel=info）</h3>
<h2>定时任务</h2>
<div>
<div>
<pre class="prettyprint linenums">在settings.py文件添加<br />
CELERYBEAT_SCHEDULE = {<br />
    'schedule-test': {<br />
        'task': 'app的名字.tasks.hello_celery',<br />
        'schedule': timedelta(seconds=3),<br />
        'args': (2,)<br />
    },

}</pre>
</div>
<p>settings.py</p></div>
<p>启动： celery -A 你的工程名称 beat -l info（或者python manage.py celery beat --loglevel=info）</p>
<h3>计划任务时间</h3>
<div>
<pre class="prettyprint linenums">from celery.schedules import crontab<br />
crontab(minute=u'', hour=u'',day_of_week='mon,tue,wed,thu,sun')

示例如下：<br />
 'every-week-three-and-four-run-get_data_with_param':{<br />
        'task': 'APP的名字.tasks.get_data_with_param',<br />
        'schedule': crontab(day_of_week="3, 4"),<br />
        'args':(4, )<br />
    }</pre>
</div>
<h3>注意:</h3>
<p><strong>我们启动定时任务服务时 也要先开启worker(python manage.py celery worker --loglevel=info)</strong></p>
<p>​ 如果只开启定时服务 没有开启worker服务 那么定时任务会被放入任务队列，但是由于没有干活儿的worker 那么任务是不会被执行，当worker服务被启动后 会立刻去任务队列领任务并执行</p>
<div>
<div>
<pre class="prettyprint linenums">#&lt;分钟&gt; &lt;小时&gt; &lt;日&gt; &lt;月份&gt; &lt;星期&gt; &lt;命令&gt;

*/1    *    *    *    *    date&gt;&gt;a.txt

#用date&gt;&gt;~/crontest可以很清楚的看到测试的效果

5    *    *    *    *    ls

#指定每小时的第5分钟执行一次ls命令

30    5    *    *     *    ls

#指定每天的 5:30 执行ls命令

30    7    8    *    *    ls

#指定每月8号的7：30分执行ls命令

30    5    8    6    *    ls

#指定每年的6月8日5：30执行ls命令

30    6    *    *    0    ls

#指定每星期日的6:30执行ls命令【注：0表示星期天，1表示星期1。星期也可以用英文来表示，sun表示星期天，mon表示星期一等。】

30    3    10,20    *    *    ls

#每月10号及20号的3：30执行ls命令【注：&ldquo;,&rdquo;用来连接多个不连续的时段】

25    8-11    *    *    *    ls

#每天8-11点的第25分钟执行ls命令【注：&ldquo;-&rdquo;用来连接连续的时段】

*/15    *    *    *    *    ls

#每15分钟执行一次ls命令【即每个小时的第0 15 30 45 60分钟执行ls命令】

30    6    */10    *    *    ls

#每个月中，每隔10天6:30执行一次ls命令【即每月的1、11、21、31日是的6：30执行一次ls 命令。】

50    7    *    *    *    root    run-parts    /etc/cron.daily

#每天7：50以root 身份执行/etc/cron.daily目录中的所有可执行文件【注：run-parts参数表示执行后面目录中的所有可执行文件。】

重启服务 ：/etc/init.d/cron restart

计划是分用户的，只对当前用户显示

*/20 4 10,13 6-8 *</pre>
</div>
<p>计划任务</p></div>
<p>如果上面的重启方式不成功, 重启任务: /sbin/service crond restart</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/oqv7yzqx.html">【MSP是什么】MSP认证之项目群管理学习心得</a>
		</li>
						<li><a href="https://www.batexi.com/a/jqdlodj8.html">Android开源项目</a>
		</li>
						<li><a href="https://www.batexi.com/a/m96no54q.html">【腾讯云】腾讯云服务器搭建ftp服务器</a>
		</li>
						<li><a href="https://www.batexi.com/a/wq13k468.html">C&num;动态加载树菜单</a>
		</li>
						<li><a href="https://www.batexi.com/a/2q7kjve9.html">IOS 开发一些常用的地址</a>
		</li>
						<li><a href="https://www.batexi.com/a/rqlgk0e9.html">&lbrack;CareerCup&rsqb; 6&period;2 Dominos on Chess Board 棋盘上的多米诺</a>
		</li>
						<li><a href="https://www.batexi.com/a/93xoye09.html">ofbiz进击 第五节。 --OFBiz配置之&lbrack;general&period;properties&rsqb; 共有属性的分析&lpar;含email&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qydv0dmq.html">QQ分组实现，可收缩---ExpandableListView</a>
		</li>
						<li><a href="https://www.batexi.com/a/90vj7z48.html">Ensemble Learning 之 Bagging 与 Random Forest</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j0p4v4q.html">推荐5个应用 jQuery 特效的精美特效</a>
		</li>
						<li><a href="https://www.batexi.com/a/qydgpodq.html">Ruby on Rails Tutorial 第二章 之 微博资源</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2wr3wvq.html">也谈js函数节流</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnjnyvx8.html">使用Gradle创建java web项目</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2jxx0x8.html">拦截asp&period;net输出流做处理&comma; 拦截HTML文本（asp&period;net webForm版&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/8ojexexq.html">Selenium for C&num;&lpar;一&rpar; 环境安装</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwldxml9.html">（maven项目）使用java -jar命令遇到的小问题&vert;xx&period;jar中没有主清单或Error&colon;Invalid or corrupt jarfile xx&period;jar</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7e704k9.html">nginx upstream 实现负载均衡</a>
		</li>
						<li><a href="https://www.batexi.com/a/8em5r0j9.html">基于qml创建最简单的图像处理程序（1）-基于qml创建界面</a>
		</li>
						<li><a href="https://www.batexi.com/a/ql15vne9.html">ios 从网络上获取图片</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4pn7l3q.html">1&period;1&period;1 A&plus;B for Input-Output Practice &lpar;I&rpar;</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/qyyg6ddq.html">vue开发记录--通用时间格式函数</a>
			</li>
						<li><a href="https://www.batexi.com/a/8m2kxe6q.html">&lbrack;vue&rsqb;mvc模式和mvvm模式及vue学习思路&lpar;废弃&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/8zy3lzd9.html">8 &period; IO类-标准IO、文件IO、stringIO</a>
			</li>
						<li><a href="https://www.batexi.com/a/95gdn5mq.html">javascript callback</a>
			</li>
						<li><a href="https://www.batexi.com/a/8e4w2jx9.html">JavaScript 常用数组函数方法专题</a>
			</li>
						<li><a href="https://www.batexi.com/a/q4jd15jq.html">mybatis常见问题和错误</a>
			</li>
						<li><a href="https://www.batexi.com/a/qllv0yxq.html">Hdu2033 人见人爱A&plus;B （贪心）</a>
			</li>
						<li><a href="https://www.batexi.com/a/95gdkr0q.html">VMware vSphere 5&period;x 与 vSphere 6&period;0各版本功能特性对比</a>
			</li>
						<li><a href="https://www.batexi.com/a/8e4wlrx9.html">C&plus;&plus; 打印机设置</a>
			</li>
						<li><a href="https://www.batexi.com/a/90ryx5n9.html">&amp;quot&semi;远程服务器返回错误&colon; &lpar;500&rpar; 内部服务器错误&amp;quot&semi;错误处理</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
